#define OV7670_REG_NUM   114
#define OV7670_ADDR      0x42
#include "One_Camera_objects.h"
#include "One_Camera_resources.h"
//------------------------------------------------------------------------------
//CAMERA Status Flag
char Vsyncf;
unsigned Y1;
unsigned width = 320;
unsigned height = 240;
unsigned int LineCounter = 0; 

//Cameras Control Lines
sbit WEN       at GPIOD_ODR.B15; //D15
sbit RRST      at GPIOD_ODR.B13; //D13
sbit RCLK      at GPIOD_ODR.B12; //D12
sbit WRST      at GPIOD_ODR.B14; //D14
sbit HREF      at GPIOB_IDR.B1;  // B1
sbit VSYN      at GPIOB_IDR.B0;  // B0
const unsigned char OV7670_Reg[OV7670_REG_NUM][2]=
{  /*  OV7670 QVGA RGB565  */
  {0x3a,0x04},{0x40,0x10},{0x12,0x14},{0x32,0x80},{0x17,0x16},{0x18,0x04},
  {0x19,0x02},{0x1a,0x7b},{0x03,0x06},{0x0c,0x0c},{0x15,0x02},{0x3e,0x00},
  {0x70,0x00},{0x71,0x01},{0x72,0x11},{0x73,0x09},{0xa2,0x02},{0x11,0x00},
  {0x7a,0x20},{0x7b,0x1c},{0x7c,0x28},{0x7d,0x3c},{0x7e,0x55},{0x7f,0x68},
  {0x80,0x76},{0x81,0x80},{0x82,0x88},{0x83,0x8f},{0x84,0x96},{0x85,0xa3},
  {0x86,0xaf},{0x87,0xc4},{0x88,0xd7},{0x89,0xe8},{0x13,0xe0},{0x00,0x00},
  {0x10,0x00},{0x0d,0x00},{0x14,0x20},{0xa5,0x05},{0xab,0x07},{0x24,0x75},
  {0x25,0x63},{0x26,0xA5},{0x9f,0x78},{0xa0,0x68},{0xa1,0x03},{0xa6,0xdf},
  {0xa7,0xdf},{0xa8,0xf0},{0xa9,0x90},{0xaa,0x94},{0x13,0xe5},{0x0e,0x61},
  {0x0f,0x4b},{0x16,0x02},{0x1e,0x37},{0x21,0x02},{0x22,0x91},{0x29,0x07},
  {0x33,0x0b},{0x35,0x0b},{0x37,0x1d},{0x38,0x71},{0x39,0x2a},{0x3c,0x78},
  {0x4d,0x40},{0x4e,0x20},{0x69,0x5d},{0x6b,0x40},{0x74,0x19},{0x8d,0x4f},
  {0x8e,0x00},{0x8f,0x00},{0x90,0x00},{0x91,0x00},{0x92,0x00},{0x96,0x00},
  {0x9a,0x80},{0xb0,0x84},{0xb1,0x0c},{0xb2,0x0e},{0xb3,0x82},{0xb8,0x0a},
  {0x43,0x14},{0x44,0xf0},{0x45,0x34},{0x46,0x58},{0x47,0x28},{0x48,0x3a},
  {0x59,0x88},{0x5a,0x88},{0x5b,0x44},{0x5c,0x67},{0x5d,0x49},{0x5e,0x0e},
  {0x64,0x04},{0x65,0x20},{0x66,0x05},{0x94,0x04},{0x95,0x08},{0x6c,0x0a},
  {0x6d,0x55},{0x4f,0x80},{0x50,0x80},{0x51,0x00},{0x52,0x22},{0x53,0x5e},
  {0x54,0x80},{0x6e,0x11},{0x6f,0x9f},{0x55,0x00},{0x56,0x40},{0x57,0x80}
  /* change according to Jim's request */
};
// RGB LED
sbit LEDR      at GPIOG_ODR.B15; // Red   of RGB_LED
sbit LEDG      at GPIOB_ODR.B3;  // Green of RGB_LED
sbit LEDB      at GPIOB_ODR.B4;  // Blue  of RGB_LED
// Software I2C connections
sbit Soft_I2C_Scl_Output    at GPIOF_ODR.B1;
sbit Soft_I2C_Scl_Input     at GPIOF_IDR.B1;
sbit Soft_I2C_Sda_Output    at GPIOF_ODR.B0;
sbit Soft_I2C_Sda_Input     at GPIOF_IDR.B0;
//----------------External Variables and Functions -----------------------------
extern sbit sfr TFT_CS;
extern void ReDrawLabel( TLabel *,char *);
//------------------------------------------------------------------------------
//                       Function Declaration
//------------------------------------------------------------------------------
void Cam_Display();
//------------------------------------------------------------------------------
void Vsync_Int() iv IVT_INT_EXTI0 ics ICS_AUTO {
  EXTI_PR.B0 = 1;       // clear flag

  switch (Vsyncf) { //Start Capture Frame
   case 0: {
            WEN  = 1;
            Vsyncf = 1;
            WRST = 0;
            asm nop;
            asm nop;
            asm nop;
            asm nop;
            WRST = 1;   // Reset Wrte Address
            }
            break;
   case 1:  Vsyncf = 2;
            WEN = 0;
        break;
   default: LEDR = 0;
            WEN = 0;
     break;
  }
}
//------------------------------------------------------------------------------
  void Init_CAM_PIN() {
  // Vsync Input and HREF  Input
  GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_0|_GPIO_PINMASK_1);
  //Data lines E0-E5,C6,C7
  GPIO_Digital_Input(&GPIOE_BASE, _GPIO_PINMASK_0|_GPIO_PINMASK_1|
                                  _GPIO_PINMASK_2|_GPIO_PINMASK_3|
                                  _GPIO_PINMASK_4|_GPIO_PINMASK_5);
  GPIO_Digital_Input(&GPIOC_BASE, _GPIO_PINMASK_6|_GPIO_PINMASK_7);
  GPIOEEN_bit = 1;
  GPIOCEN_bit = 1;
  // RCLK, RRST, WRST, WEN
  GPIO_Digital_Output(&GPIOD_BASE,_GPIO_PINMASK_12|_GPIO_PINMASK_13|
                                  _GPIO_PINMASK_14|_GPIO_PINMASK_15);
  WEN   = 0;
  RRST  = 1;
  RCLK  = 0;
  WRST  = 0;
  // LED Port Configuration
  GPIO_Digital_Output(&GPIOB_BASE,_GPIO_PINMASK_3|_GPIO_PINMASK_4); //Green,Blue
  GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15); //Red
  LEDR  = 0;       // RED-LED   OFF
  LEDG  = 0;       // GREEN-LED OFF
  LEDB  = 0;       // BLUE-LED  OFF
}
//------------------------------------------------------------------------------
void Setup_Interrupt(){              // Init Interrupt on PB0 Vsync
  SYSCFGEN_bit = 1;                  // Enable clock for alternate pin functions
  SYSCFG_EXTICR1 |= 0x00000001;      // Map external interrupt on PC2,
  EXTI_RTSR      |= 0x00000000;      // Set interrupt on Rising edge (Int2,Int4)
  EXTI_FTSR      |= 0x00000001;      // Set Interrupt on Falling edge(Int2,Int4)
  EXTI_IMR       |= 0x00000001;      // Set mask
  NVIC_IntEnable(IVT_INT_EXTI0);     // Enable External interrupt 0 VSync
}
//------------------------------------------------------------------------------
  void softframe(){

  int i;
  unsigned char data_[2];
  char txt[10];
  Soft_I2C_Init();
  Delay_us(25);
  for (i = 0; i <= OV7670_REG_NUM; i++){
   Soft_I2C_Start();
   Soft_I2C_Write(OV7670_ADDR);
   Delay_us(1);
   Soft_I2C_Write(OV7670_Reg[i][0]);
   Delay_us(1);
   Soft_I2C_Write(OV7670_Reg[i][1]);
   Delay_us(5);
   Soft_I2C_Stop();
  Delay_us(25);
   }
  }
//------------------------------------------------------------------------------
void Init_Cam(){

  Init_CAM_PIN();
  Setup_Interrupt();
  Circle1.Color = CL_RED;
  DrawCircle(&Circle1);
  Circle2.Color = CL_RED;
  DrawCircle(&Circle2);
  Vsyncf = 0;
  Softframe();
  Circle3.Color = CL_RED;
  DrawCircle(&Circle3);
}
//------------------------------------------------------------------------------
void Cam_Display(){
   unsigned i,j;
   
   RCLK = 0;
   RRST = 0;
   Delay_us(1);
   RCLK = 1;
   asm nop;
   RRST = 1;
   TFT_CS = 0;
   TFT_SSD1963_Set_Address_Ptr(0, 0, width -1, height-1);
   for ( j = 0; j < height; j++){
     for (i = 0; i < width; i++){
       Y1  = ((GPIOE_IDR & 0x003F)|(GPIOC_IDR & 0x00C0)) ;
       RCLK = 0;  // Byte-1
       asm nop;
       asm nop;
       RCLK = 1;
       asm nop;
       asm nop;
       Y1 |= (((GPIOE_IDR &0x003F)|(GPIOC_IDR & 0x00C0))<<8) ;
       TFT_Write_Data_Ptr(Y1);      
       RCLK = 0; //Byte-2
       asm nop;
       RCLK = 1;
       asm nop;
     }
   }
   TFT_CS = 1;
}
//------------------------------------------------------------------------------