#line 1 "//psf/Home/Projects/ARM_STM/OV7670_Camera/OV7670_Driver.c"
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
};

extern TScreen Screen1;
extern TCircle Circle1;
extern TCircle Circle2;
extern TCircle Circle3;
extern TCircle Circle4;
extern TCircle Circle5;
extern TCircle Circle6;
extern TCircle Circle7;
extern TCircle Circle8;
extern TCircle Circle9;
extern TCircle Circle10;
extern TCircle Circle11;
extern TCircle Circle12;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TButton Button1;
extern TButton Button2;
extern TButton * const code Screen1_Buttons[2];
extern TLabel * const code Screen1_Labels[3];
extern TCircle * const code Screen1_Circles[12];




void BTN_DCR();
void BTN_INC();




extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Circle3_Caption[];
extern char Circle4_Caption[];
extern char Circle5_Caption[];
extern char Circle6_Caption[];
extern char Circle7_Caption[];
extern char Circle8_Caption[];
extern char Circle9_Caption[];
extern char Circle10_Caption[];
extern char Circle11_Caption[];
extern char Circle12_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_resources.h"
const code char Tahoma19x23_Regular[];
const code char Tahoma11x13_Regular[];
#line 7 "//psf/Home/Projects/ARM_STM/OV7670_Camera/OV7670_Driver.c"
char Vsyncf;
unsigned Y1;
unsigned width = 320;
unsigned height = 240;
unsigned int LineCounter = 0;


sbit WEN at GPIOD_ODR.B15;
sbit RRST at GPIOD_ODR.B13;
sbit RCLK at GPIOD_ODR.B12;
sbit WRST at GPIOD_ODR.B14;
sbit HREF at GPIOB_IDR.B1;
sbit VSYN at GPIOB_IDR.B0;
const unsigned char OV7670_Reg[ 114 ][2]=
{
 {0x3a,0x04},{0x40,0x10},{0x12,0x14},{0x32,0x80},{0x17,0x16},{0x18,0x04},
 {0x19,0x02},{0x1a,0x7b},{0x03,0x06},{0x0c,0x0c},{0x15,0x02},{0x3e,0x00},
 {0x70,0x00},{0x71,0x01},{0x72,0x11},{0x73,0x09},{0xa2,0x02},{0x11,0x00},
 {0x7a,0x20},{0x7b,0x1c},{0x7c,0x28},{0x7d,0x3c},{0x7e,0x55},{0x7f,0x68},
 {0x80,0x76},{0x81,0x80},{0x82,0x88},{0x83,0x8f},{0x84,0x96},{0x85,0xa3},
 {0x86,0xaf},{0x87,0xc4},{0x88,0xd7},{0x89,0xe8},{0x13,0xe0},{0x00,0x00},
 {0x10,0x00},{0x0d,0x00},{0x14,0x20},{0xa5,0x05},{0xab,0x07},{0x24,0x75},
 {0x25,0x63},{0x26,0xA5},{0x9f,0x78},{0xa0,0x68},{0xa1,0x03},{0xa6,0xdf},
 {0xa7,0xdf},{0xa8,0xf0},{0xa9,0x90},{0xaa,0x94},{0x13,0xe5},{0x0e,0x61},
 {0x0f,0x4b},{0x16,0x02},{0x1e,0x37},{0x21,0x02},{0x22,0x91},{0x29,0x07},
 {0x33,0x0b},{0x35,0x0b},{0x37,0x1d},{0x38,0x71},{0x39,0x2a},{0x3c,0x78},
 {0x4d,0x40},{0x4e,0x20},{0x69,0x5d},{0x6b,0x40},{0x74,0x19},{0x8d,0x4f},
 {0x8e,0x00},{0x8f,0x00},{0x90,0x00},{0x91,0x00},{0x92,0x00},{0x96,0x00},
 {0x9a,0x80},{0xb0,0x84},{0xb1,0x0c},{0xb2,0x0e},{0xb3,0x82},{0xb8,0x0a},
 {0x43,0x14},{0x44,0xf0},{0x45,0x34},{0x46,0x58},{0x47,0x28},{0x48,0x3a},
 {0x59,0x88},{0x5a,0x88},{0x5b,0x44},{0x5c,0x67},{0x5d,0x49},{0x5e,0x0e},
 {0x64,0x04},{0x65,0x20},{0x66,0x05},{0x94,0x04},{0x95,0x08},{0x6c,0x0a},
 {0x6d,0x55},{0x4f,0x80},{0x50,0x80},{0x51,0x00},{0x52,0x22},{0x53,0x5e},
 {0x54,0x80},{0x6e,0x11},{0x6f,0x9f},{0x55,0x00},{0x56,0x40},{0x57,0x80}

};

sbit LEDR at GPIOG_ODR.B15;
sbit LEDG at GPIOB_ODR.B3;
sbit LEDB at GPIOB_ODR.B4;

sbit Soft_I2C_Scl_Output at GPIOF_ODR.B1;
sbit Soft_I2C_Scl_Input at GPIOF_IDR.B1;
sbit Soft_I2C_Sda_Output at GPIOF_ODR.B0;
sbit Soft_I2C_Sda_Input at GPIOF_IDR.B0;

extern sbit sfr TFT_CS;
extern void ReDrawLabel( TLabel *,char *);



void Cam_Display();

void Vsync_Int() iv IVT_INT_EXTI0 ics ICS_AUTO {
 EXTI_PR.B0 = 1;

 switch (Vsyncf) {
 case 0: {
 WEN = 1;
 Vsyncf = 1;
 WRST = 0;
 asm nop;
 asm nop;
 asm nop;
 asm nop;
 WRST = 1;
 }
 break;
 case 1: Vsyncf = 2;
 WEN = 0;
 break;
 default: LEDR = 0;
 WEN = 0;
 break;
 }
}

 void Init_CAM_PIN() {

 GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_0|_GPIO_PINMASK_1);

 GPIO_Digital_Input(&GPIOE_BASE, _GPIO_PINMASK_0|_GPIO_PINMASK_1|
 _GPIO_PINMASK_2|_GPIO_PINMASK_3|
 _GPIO_PINMASK_4|_GPIO_PINMASK_5);
 GPIO_Digital_Input(&GPIOC_BASE, _GPIO_PINMASK_6|_GPIO_PINMASK_7);
 GPIOEEN_bit = 1;
 GPIOCEN_bit = 1;

 GPIO_Digital_Output(&GPIOD_BASE,_GPIO_PINMASK_12|_GPIO_PINMASK_13|
 _GPIO_PINMASK_14|_GPIO_PINMASK_15);
 WEN = 0;
 RRST = 1;
 RCLK = 0;
 WRST = 0;

 GPIO_Digital_Output(&GPIOB_BASE,_GPIO_PINMASK_3|_GPIO_PINMASK_4);
 GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15);
 LEDR = 0;
 LEDG = 0;
 LEDB = 0;
}

void Setup_Interrupt(){
 SYSCFGEN_bit = 1;
 SYSCFG_EXTICR1 |= 0x00000001;
 EXTI_RTSR |= 0x00000000;
 EXTI_FTSR |= 0x00000001;
 EXTI_IMR |= 0x00000001;
 NVIC_IntEnable(IVT_INT_EXTI0);
}

 void softframe(){

 int i;
 unsigned char data_[2];
 char txt[10];
 Soft_I2C_Init();
 Delay_us(25);
 for (i = 0; i <=  114 ; i++){
 Soft_I2C_Start();
 Soft_I2C_Write( 0x42 );
 Delay_us(1);
 Soft_I2C_Write(OV7670_Reg[i][0]);
 Delay_us(1);
 Soft_I2C_Write(OV7670_Reg[i][1]);
 Delay_us(5);
 Soft_I2C_Stop();
 Delay_us(25);
 }
 }

void Init_Cam(){

 Init_CAM_PIN();
 Setup_Interrupt();
 Circle1.Color = CL_RED;
 DrawCircle(&Circle1);
 Circle2.Color = CL_RED;
 DrawCircle(&Circle2);
 Vsyncf = 0;
 Softframe();
 Circle3.Color = CL_RED;
 DrawCircle(&Circle3);
}

void Cam_Display(){
 unsigned i,j;

 RCLK = 0;
 RRST = 0;
 Delay_us(1);
 RCLK = 1;
 asm nop;
 RRST = 1;
 TFT_CS = 0;
 TFT_SSD1963_Set_Address_Ptr(0, 0, width -1, height-1);
 for ( j = 0; j < height; j++){
 for (i = 0; i < width; i++){
 Y1 = ((GPIOE_IDR & 0x003F)|(GPIOC_IDR & 0x00C0)) ;
 RCLK = 0;
 asm nop;
 asm nop;
 RCLK = 1;
 asm nop;
 asm nop;
 Y1 |= (((GPIOE_IDR &0x003F)|(GPIOC_IDR & 0x00C0))<<8) ;
 TFT_Write_Data_Ptr(Y1);
 RCLK = 0;
 asm nop;
 RCLK = 1;
 asm nop;
 }
 }
 TFT_CS = 1;
}
