#line 1 "//psf/Home/Projects/ARM_STM/OV7670_Camera/One_Camera_driver.c"
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
};

extern TScreen Screen1;
extern TCircle Circle1;
extern TCircle Circle2;
extern TCircle Circle3;
extern TCircle Circle4;
extern TCircle Circle5;
extern TCircle Circle6;
extern TCircle Circle7;
extern TCircle Circle8;
extern TCircle Circle9;
extern TCircle Circle10;
extern TCircle Circle11;
extern TCircle Circle12;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TButton Button1;
extern TButton Button2;
extern TButton * const code Screen1_Buttons[2];
extern TLabel * const code Screen1_Labels[3];
extern TCircle * const code Screen1_Circles[12];




void BTN_DCR();
void BTN_INC();




extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Circle3_Caption[];
extern char Circle4_Caption[];
extern char Circle5_Caption[];
extern char Circle6_Caption[];
extern char Circle7_Caption[];
extern char Circle8_Caption[];
extern char Circle9_Caption[];
extern char Circle10_Caption[];
extern char Circle11_Caption[];
extern char Circle12_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_resources.h"
const code char Tahoma19x23_Regular[];
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 7 "//psf/Home/Projects/ARM_STM/OV7670_Camera/One_Camera_driver.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_CS at GPIOF_ODR.B13;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_WR at GPIOF_ODR.B11;
sbit TFT_BLED at GPIOF_ODR.B10;




unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TCircle *local_circle;
TCircle *exec_circle;
int circle_order;


void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
 unsigned int temp;
 temp = GPIOE_ODR;
 temp &= 0x00FF;
 GPIOE_ODR = temp | (_hi << 8);
 temp = GPIOG_ODR;
 temp &= 0xFF00;
 GPIOG_ODR = temp | _lo;
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 Write_to_Data_Lines(0, index);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
 TFT_RS = 1;
 Write_to_Data_Lines(0, cmd);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 Write_to_Data_Lines( ((char *)&_data)[1] ,  ((char *)&_data)[0] );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void InitializeTouchPanel() {
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(480, 272);

 TFT_Set_DBC_SSD1963(255);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TCircle Circle1;
 TCircle Circle2;
 TCircle Circle3;
 TCircle Circle4;
 TCircle Circle5;
 TCircle Circle6;
 TCircle Circle7;
 TCircle Circle8;
 TCircle Circle9;
 TCircle Circle10;
 TCircle Circle11;
 TCircle Circle12;
 TLabel Label1;
char Label1_Caption[4] = "000";

 TLabel Label2;
char Label2_Caption[4] = "000";

 TLabel Label3;
char Label3_Caption[4] = "000";

 TButton Button1;
char Button1_Caption[3] = "<<";

 TButton Button2;
char Button2_Caption[3] = ">>";

 TButton * const code Screen1_Buttons[2]=
 {
 &Button1,
 &Button2
 };
 TLabel * const code Screen1_Labels[3]=
 {
 &Label1,
 &Label2,
 &Label3
 };
 TCircle * const code Screen1_Circles[12]=
 {
 &Circle1,
 &Circle2,
 &Circle3,
 &Circle4,
 &Circle5,
 &Circle6,
 &Circle7,
 &Circle8,
 &Circle9,
 &Circle10,
 &Circle11,
 &Circle12
 };



static void InitializeObjects() {
 Screen1.Color = 0x0400;
 Screen1.Width = 480;
 Screen1.Height = 272;
 Screen1.ButtonsCount = 2;
 Screen1.Buttons = Screen1_Buttons;
 Screen1.LabelsCount = 3;
 Screen1.Labels = Screen1_Labels;
 Screen1.CirclesCount = 12;
 Screen1.Circles = Screen1_Circles;
 Screen1.ObjectsCount = 17;


 Circle1.OwnerScreen = &Screen1;
 Circle1.Order = 0;
 Circle1.Left = 14;
 Circle1.Top = 252;
 Circle1.Radius = 6;
 Circle1.Pen_Width = 1;
 Circle1.Pen_Color = 0x0000;
 Circle1.Visible = 1;
 Circle1.Active = 1;
 Circle1.Transparent = 1;
 Circle1.Gradient = 0;
 Circle1.Gradient_Orientation = 0;
 Circle1.Gradient_Start_Color = 0xFFFF;
 Circle1.Gradient_End_Color = 0xC618;
 Circle1.Color = 0x8000;
 Circle1.PressColEnabled = 1;
 Circle1.Press_Color = 0xE71C;
 Circle1.OnUpPtr = 0;
 Circle1.OnDownPtr = 0;
 Circle1.OnClickPtr = 0;
 Circle1.OnPressPtr = 0;

 Circle2.OwnerScreen = &Screen1;
 Circle2.Order = 1;
 Circle2.Left = 34;
 Circle2.Top = 252;
 Circle2.Radius = 6;
 Circle2.Pen_Width = 1;
 Circle2.Pen_Color = 0x0000;
 Circle2.Visible = 1;
 Circle2.Active = 1;
 Circle2.Transparent = 1;
 Circle2.Gradient = 0;
 Circle2.Gradient_Orientation = 0;
 Circle2.Gradient_Start_Color = 0xFFFF;
 Circle2.Gradient_End_Color = 0xC618;
 Circle2.Color = 0x8000;
 Circle2.PressColEnabled = 1;
 Circle2.Press_Color = 0xE71C;
 Circle2.OnUpPtr = 0;
 Circle2.OnDownPtr = 0;
 Circle2.OnClickPtr = 0;
 Circle2.OnPressPtr = 0;

 Circle3.OwnerScreen = &Screen1;
 Circle3.Order = 2;
 Circle3.Left = 54;
 Circle3.Top = 252;
 Circle3.Radius = 6;
 Circle3.Pen_Width = 1;
 Circle3.Pen_Color = 0x0000;
 Circle3.Visible = 1;
 Circle3.Active = 1;
 Circle3.Transparent = 1;
 Circle3.Gradient = 0;
 Circle3.Gradient_Orientation = 0;
 Circle3.Gradient_Start_Color = 0xFFFF;
 Circle3.Gradient_End_Color = 0xC618;
 Circle3.Color = 0x8000;
 Circle3.PressColEnabled = 1;
 Circle3.Press_Color = 0xE71C;
 Circle3.OnUpPtr = 0;
 Circle3.OnDownPtr = 0;
 Circle3.OnClickPtr = 0;
 Circle3.OnPressPtr = 0;

 Circle4.OwnerScreen = &Screen1;
 Circle4.Order = 3;
 Circle4.Left = 74;
 Circle4.Top = 252;
 Circle4.Radius = 6;
 Circle4.Pen_Width = 1;
 Circle4.Pen_Color = 0x0000;
 Circle4.Visible = 1;
 Circle4.Active = 1;
 Circle4.Transparent = 1;
 Circle4.Gradient = 0;
 Circle4.Gradient_Orientation = 0;
 Circle4.Gradient_Start_Color = 0xFFFF;
 Circle4.Gradient_End_Color = 0xC618;
 Circle4.Color = 0x8000;
 Circle4.PressColEnabled = 1;
 Circle4.Press_Color = 0xE71C;
 Circle4.OnUpPtr = 0;
 Circle4.OnDownPtr = 0;
 Circle4.OnClickPtr = 0;
 Circle4.OnPressPtr = 0;

 Circle5.OwnerScreen = &Screen1;
 Circle5.Order = 4;
 Circle5.Left = 94;
 Circle5.Top = 252;
 Circle5.Radius = 6;
 Circle5.Pen_Width = 1;
 Circle5.Pen_Color = 0x0000;
 Circle5.Visible = 1;
 Circle5.Active = 1;
 Circle5.Transparent = 1;
 Circle5.Gradient = 0;
 Circle5.Gradient_Orientation = 0;
 Circle5.Gradient_Start_Color = 0xFFFF;
 Circle5.Gradient_End_Color = 0xC618;
 Circle5.Color = 0x8000;
 Circle5.PressColEnabled = 1;
 Circle5.Press_Color = 0xE71C;
 Circle5.OnUpPtr = 0;
 Circle5.OnDownPtr = 0;
 Circle5.OnClickPtr = 0;
 Circle5.OnPressPtr = 0;

 Circle6.OwnerScreen = &Screen1;
 Circle6.Order = 5;
 Circle6.Left = 114;
 Circle6.Top = 252;
 Circle6.Radius = 6;
 Circle6.Pen_Width = 1;
 Circle6.Pen_Color = 0x0000;
 Circle6.Visible = 1;
 Circle6.Active = 1;
 Circle6.Transparent = 1;
 Circle6.Gradient = 0;
 Circle6.Gradient_Orientation = 0;
 Circle6.Gradient_Start_Color = 0xFFFF;
 Circle6.Gradient_End_Color = 0xC618;
 Circle6.Color = 0x8000;
 Circle6.PressColEnabled = 1;
 Circle6.Press_Color = 0xE71C;
 Circle6.OnUpPtr = 0;
 Circle6.OnDownPtr = 0;
 Circle6.OnClickPtr = 0;
 Circle6.OnPressPtr = 0;

 Circle7.OwnerScreen = &Screen1;
 Circle7.Order = 6;
 Circle7.Left = 134;
 Circle7.Top = 252;
 Circle7.Radius = 6;
 Circle7.Pen_Width = 1;
 Circle7.Pen_Color = 0x0000;
 Circle7.Visible = 1;
 Circle7.Active = 1;
 Circle7.Transparent = 1;
 Circle7.Gradient = 0;
 Circle7.Gradient_Orientation = 0;
 Circle7.Gradient_Start_Color = 0xFFFF;
 Circle7.Gradient_End_Color = 0xC618;
 Circle7.Color = 0x8000;
 Circle7.PressColEnabled = 1;
 Circle7.Press_Color = 0xE71C;
 Circle7.OnUpPtr = 0;
 Circle7.OnDownPtr = 0;
 Circle7.OnClickPtr = 0;
 Circle7.OnPressPtr = 0;

 Circle8.OwnerScreen = &Screen1;
 Circle8.Order = 7;
 Circle8.Left = 154;
 Circle8.Top = 252;
 Circle8.Radius = 6;
 Circle8.Pen_Width = 1;
 Circle8.Pen_Color = 0x0000;
 Circle8.Visible = 1;
 Circle8.Active = 1;
 Circle8.Transparent = 1;
 Circle8.Gradient = 0;
 Circle8.Gradient_Orientation = 0;
 Circle8.Gradient_Start_Color = 0xFFFF;
 Circle8.Gradient_End_Color = 0xC618;
 Circle8.Color = 0x8000;
 Circle8.PressColEnabled = 1;
 Circle8.Press_Color = 0xE71C;
 Circle8.OnUpPtr = 0;
 Circle8.OnDownPtr = 0;
 Circle8.OnClickPtr = 0;
 Circle8.OnPressPtr = 0;

 Circle9.OwnerScreen = &Screen1;
 Circle9.Order = 8;
 Circle9.Left = 174;
 Circle9.Top = 252;
 Circle9.Radius = 6;
 Circle9.Pen_Width = 1;
 Circle9.Pen_Color = 0x0000;
 Circle9.Visible = 1;
 Circle9.Active = 1;
 Circle9.Transparent = 1;
 Circle9.Gradient = 0;
 Circle9.Gradient_Orientation = 0;
 Circle9.Gradient_Start_Color = 0xFFFF;
 Circle9.Gradient_End_Color = 0xC618;
 Circle9.Color = 0x8000;
 Circle9.PressColEnabled = 1;
 Circle9.Press_Color = 0xE71C;
 Circle9.OnUpPtr = 0;
 Circle9.OnDownPtr = 0;
 Circle9.OnClickPtr = 0;
 Circle9.OnPressPtr = 0;

 Circle10.OwnerScreen = &Screen1;
 Circle10.Order = 9;
 Circle10.Left = 194;
 Circle10.Top = 252;
 Circle10.Radius = 6;
 Circle10.Pen_Width = 1;
 Circle10.Pen_Color = 0x0000;
 Circle10.Visible = 1;
 Circle10.Active = 1;
 Circle10.Transparent = 1;
 Circle10.Gradient = 0;
 Circle10.Gradient_Orientation = 0;
 Circle10.Gradient_Start_Color = 0xFFFF;
 Circle10.Gradient_End_Color = 0xC618;
 Circle10.Color = 0x8000;
 Circle10.PressColEnabled = 1;
 Circle10.Press_Color = 0xE71C;
 Circle10.OnUpPtr = 0;
 Circle10.OnDownPtr = 0;
 Circle10.OnClickPtr = 0;
 Circle10.OnPressPtr = 0;

 Circle11.OwnerScreen = &Screen1;
 Circle11.Order = 10;
 Circle11.Left = 214;
 Circle11.Top = 252;
 Circle11.Radius = 6;
 Circle11.Pen_Width = 1;
 Circle11.Pen_Color = 0x0000;
 Circle11.Visible = 1;
 Circle11.Active = 1;
 Circle11.Transparent = 1;
 Circle11.Gradient = 0;
 Circle11.Gradient_Orientation = 0;
 Circle11.Gradient_Start_Color = 0xFFFF;
 Circle11.Gradient_End_Color = 0xC618;
 Circle11.Color = 0x8000;
 Circle11.PressColEnabled = 1;
 Circle11.Press_Color = 0xE71C;
 Circle11.OnUpPtr = 0;
 Circle11.OnDownPtr = 0;
 Circle11.OnClickPtr = 0;
 Circle11.OnPressPtr = 0;

 Circle12.OwnerScreen = &Screen1;
 Circle12.Order = 11;
 Circle12.Left = 234;
 Circle12.Top = 252;
 Circle12.Radius = 6;
 Circle12.Pen_Width = 1;
 Circle12.Pen_Color = 0x0000;
 Circle12.Visible = 1;
 Circle12.Active = 1;
 Circle12.Transparent = 1;
 Circle12.Gradient = 0;
 Circle12.Gradient_Orientation = 0;
 Circle12.Gradient_Start_Color = 0xFFFF;
 Circle12.Gradient_End_Color = 0xC618;
 Circle12.Color = 0x8000;
 Circle12.PressColEnabled = 1;
 Circle12.Press_Color = 0xE71C;
 Circle12.OnUpPtr = 0;
 Circle12.OnDownPtr = 0;
 Circle12.OnClickPtr = 0;
 Circle12.OnPressPtr = 0;

 Label1.OwnerScreen = &Screen1;
 Label1.Order = 12;
 Label1.Left = 334;
 Label1.Top = 9;
 Label1.Width = 19;
 Label1.Height = 15;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma11x13_Regular;
 Label1.Font_Color = 0xC800;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 13;
 Label2.Left = 387;
 Label2.Top = 56;
 Label2.Width = 32;
 Label2.Height = 25;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma19x23_Regular;
 Label2.Font_Color = 0xC800;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen1;
 Label3.Order = 14;
 Label3.Left = 430;
 Label3.Top = 9;
 Label3.Width = 19;
 Label3.Height = 15;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma11x13_Regular;
 Label3.Font_Color = 0xC800;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Button1.OwnerScreen = &Screen1;
 Button1.Order = 15;
 Button1.Left = 341;
 Button1.Top = 87;
 Button1.Width = 40;
 Button1.Height = 60;
 Button1.Pen_Width = 1;
 Button1.Pen_Color = 0x0000;
 Button1.Visible = 1;
 Button1.Active = 1;
 Button1.Transparent = 1;
 Button1.Caption = Button1_Caption;
 Button1.TextAlign = _taCenter;
 Button1.FontName = Tahoma11x13_Regular;
 Button1.PressColEnabled = 1;
 Button1.Font_Color = 0x0000;
 Button1.Gradient = 1;
 Button1.Gradient_Orientation = 0;
 Button1.Gradient_Start_Color = 0xFFFF;
 Button1.Gradient_End_Color = 0xC618;
 Button1.Color = 0xC618;
 Button1.Press_Color = 0xE71C;
 Button1.OnUpPtr = 0;
 Button1.OnDownPtr = 0;
 Button1.OnClickPtr = BTN_DCR;
 Button1.OnPressPtr = 0;

 Button2.OwnerScreen = &Screen1;
 Button2.Order = 16;
 Button2.Left = 425;
 Button2.Top = 87;
 Button2.Width = 40;
 Button2.Height = 60;
 Button2.Pen_Width = 1;
 Button2.Pen_Color = 0x0000;
 Button2.Visible = 1;
 Button2.Active = 1;
 Button2.Transparent = 1;
 Button2.Caption = Button2_Caption;
 Button2.TextAlign = _taCenter;
 Button2.FontName = Tahoma11x13_Regular;
 Button2.PressColEnabled = 1;
 Button2.Font_Color = 0x0000;
 Button2.Gradient = 1;
 Button2.Gradient_Orientation = 0;
 Button2.Gradient_Start_Color = 0xFFFF;
 Button2.Gradient_End_Color = 0xC618;
 Button2.Color = 0xC618;
 Button2.Press_Color = 0xE71C;
 Button2.OnUpPtr = 0;
 Button2.OnDownPtr = 0;
 Button2.OnClickPtr = BTN_INC;
 Button2.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}







void DrawButton(TButton *Abutton) {
 if (Abutton->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
 }
 TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
 TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
 if (Abutton->TextAlign == _taLeft)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + 4, (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taCenter)
 TFT_Write_Text(Abutton->Caption, (Abutton->Left + (Abutton->Width - caption_length) / 2), (Abutton->Top + ((Abutton->Height - caption_height) / 2)));
 else if (Abutton->TextAlign == _taRight)
 TFT_Write_Text(Abutton->Caption, Abutton->Left + (Abutton->Width - caption_length - 4), (Abutton->Top + (Abutton->Height - caption_height) / 2));
 }
}

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible == 1) {
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawCircle(TCircle *ACircle) {
 if (ACircle->Visible == 1) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(ACircle->Transparent, ACircle->Press_Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_End_Color, ACircle->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(ACircle->Transparent, ACircle->Color, ACircle->Gradient, ACircle->Gradient_Orientation,
 ACircle->Gradient_Start_Color, ACircle->Gradient_End_Color);
 }
 TFT_Set_Pen(ACircle->Pen_Color, ACircle->Pen_Width);
 TFT_Circle(ACircle->Left + ACircle->Radius,
 ACircle->Top + ACircle->Radius,
 ACircle->Radius);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short button_idx;
 TButton *local_button;
 unsigned short label_idx;
 TLabel *local_label;
 unsigned short circle_idx;
 TCircle *local_circle;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 button_idx = 0;
 label_idx = 0;
 circle_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963(CurrentScreen->Width, CurrentScreen->Height);
 STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Fill_Screen(CurrentScreen->Color);
 TFT_Set_DBC_SSD1963(255);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (button_idx < CurrentScreen->ButtonsCount) {
 local_button =  CurrentScreen->Buttons[button_idx] ;
 if (order == local_button->Order) {
 button_idx++;
 order++;
 DrawButton(local_button);
 }
 }

 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 if (circle_idx < CurrentScreen->CirclesCount) {
 local_circle =  CurrentScreen->Circles[circle_idx] ;
 if (order == local_circle->Order) {
 circle_idx++;
 order++;
 DrawCircle(local_circle);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 button_order = -1;
 label_order = -1;
 circle_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
 local_button =  CurrentScreen->Buttons[_object_count] ;
 if (local_button->Active == 1) {
 if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
 local_button->Width, local_button->Height) == 1) {
 button_order = local_button->Order;
 exec_button = local_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active == 1) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->CirclesCount ; _object_count++ ) {
 local_circle =  CurrentScreen->Circles[_object_count] ;
 if (local_circle->Active == 1) {
 if (IsInsideObject(X, Y, local_circle->Left, local_circle->Top,
 (local_circle->Radius * 2), (local_circle->Radius * 2)) == 1) {
 circle_order = local_circle->Order;
 exec_circle = local_circle;
 }
 }
 }

 _object_count = -1;
 if (button_order > _object_count )
 _object_count = button_order;
 if (label_order > _object_count )
 _object_count = label_order;
 if (circle_order > _object_count )
 _object_count = circle_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_button = 0;
 exec_label = 0;
 exec_circle = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnPressPtr != 0) {
 exec_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->OnPressPtr != 0) {
 exec_circle->OnPressPtr();
 return;
 }
 }
 }

 }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 0: {
 if (PressedObject != 0) {
 exec_button = (TButton*)PressedObject;
 if ((exec_button->PressColEnabled == 1) && (exec_button->OwnerScreen == CurrentScreen)) {
 DrawButton(exec_button);
 }
 break;
 }
 break;
 }

 case 4: {
 if (PressedObject != 0) {
 exec_circle = (TCircle*)PressedObject;
 if ((exec_circle->PressColEnabled == 1) && (exec_circle->OwnerScreen == CurrentScreen)) {
 DrawCircle(exec_circle);
 }
 break;
 }
 break;
 }
 }

 exec_label = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->OnUpPtr != 0)
 exec_button->OnUpPtr();
 if (PressedObject == (void *)exec_button)
 if (exec_button->OnClickPtr != 0)
 exec_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->OnUpPtr != 0)
 exec_circle->OnUpPtr();
 if (PressedObject == (void *)exec_circle)
 if (exec_circle->OnClickPtr != 0)
 exec_circle->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_button = 0;
 exec_label = 0;
 exec_circle = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active == 1) {
 if (exec_button->PressColEnabled == 1) {
 object_pressed = 1;
 DrawButton(exec_button);
 }
 PressedObject = (void *)exec_button;
 PressedObjectType = 0;
 if (exec_button->OnDownPtr != 0) {
 exec_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active == 1) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == circle_order) {
 if (exec_circle->Active == 1) {
 if (exec_circle->PressColEnabled == 1) {
 object_pressed = 1;
 DrawCircle(exec_circle);
 }
 PressedObject = (void *)exec_circle;
 PressedObjectType = 4;
 if (exec_circle->OnDownPtr != 0) {
 exec_circle->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (STMPE610_PressDetect()) {
 if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {

 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {



 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
 GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_7);
 GPIOB_ODR.B6 = 1;
 while (GPIOB_IDR.B7 == 0) {
 GPIOB_ODR.B6 = 0;
 Delay_us(10);
 GPIOB_ODR.B6 = 1;
 Delay_us(10);
 }
 I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);

 TFT_Set_Default_Mode();
 GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
 GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
 GPIOB_ODR.B4 = 0;
 TFT_Set_Default_Mode();
 TFT_Set_MM_Plus();
 STMPE610_SetDefaultMode();
}

char STMPE610_Config() {
 STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
 if (STMPE610_IsOperational() != 0){
 return STMPE610_IO_NOT_OPERATIONAL;
 }

 STMPE610_Reset();
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
 STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);
 STMPE610_SetSize(480,272);
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH | STMPE610_IE_FIFO_0FLOW, STMPE610_ENABLE);
 STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
 STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_12BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
 Delay_10ms(); Delay_10ms();
 STMPE610_SetADCClock(STMPE610_ADC_CTRL2_3250_kHZ);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
 STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_8S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_500uS);
 STMPE610_SetFIFOThreshold(1);
 STMPE610_ResetFIFO();
 STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
 STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
 STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
 STMPE610_SetTouchPressureThreshold(70);
 STMPE610_ClearInterrupts();
 STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
 return STMPE610_OK;
}


void Start_TP() {
TTPConstants TPConstsStruct;
 Init_MCU();

 InitializeTouchPanel();
 if (STMPE610_Config() == STMPE610_OK) {
 } else {
 while(1);
 }



 TPConstsStruct.X_Min = 105;
 TPConstsStruct.X_Max = 3925;
 TPConstsStruct.Y_Min = 250;
 TPConstsStruct.Y_Max = 3820;
 TPConstsStruct.Rotate = 0;
 STMPE610_SetCalibrationConsts(&TPConstsStruct);

 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
