#line 1 "//psf/Home/Projects/ARM_STM/OV7670_Camera/One_Camera_events_code.c"
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Circle {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircle;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int CirclesCount;
 TCircle * const code *Circles;
};

extern TScreen Screen1;
extern TCircle Circle1;
extern TCircle Circle2;
extern TCircle Circle3;
extern TCircle Circle4;
extern TCircle Circle5;
extern TCircle Circle6;
extern TCircle Circle7;
extern TCircle Circle8;
extern TCircle Circle9;
extern TCircle Circle10;
extern TCircle Circle11;
extern TCircle Circle12;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TButton Button1;
extern TButton Button2;
extern TButton * const code Screen1_Buttons[2];
extern TLabel * const code Screen1_Labels[3];
extern TCircle * const code Screen1_Circles[12];




void BTN_DCR();
void BTN_INC();




extern char Circle1_Caption[];
extern char Circle2_Caption[];
extern char Circle3_Caption[];
extern char Circle4_Caption[];
extern char Circle5_Caption[];
extern char Circle6_Caption[];
extern char Circle7_Caption[];
extern char Circle8_Caption[];
extern char Circle9_Caption[];
extern char Circle10_Caption[];
extern char Circle11_Caption[];
extern char Circle12_Caption[];
extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawCircle(TCircle *ACircle);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "//psf/home/projects/arm_stm/ov7670_camera/one_camera_resources.h"
const code char Tahoma19x23_Regular[];
const code char Tahoma11x13_Regular[];
#line 3 "//psf/Home/Projects/ARM_STM/OV7670_Camera/One_Camera_events_code.c"
extern unsigned width;

void ReDrawLabel(TLabel *ALabel, char* newString) {
unsigned int FontColor;
 FontColor = ALabel -> Font_Color;
 ALabel->Font_Color = CL_GREEN;
 DrawLabel(ALabel);
 strcpy(ALabel->Caption, newString);
 ALabel->Font_Color = FontColor;
 DrawLabel(ALabel);
}



extern char txt;
void BTN_DCR() {
 if (width != 0) width--;


}

void BTN_INC() {
 if (width!=480) width ++;


}
